#include "RTreeOct.h"

octave_value RTreeOct::constructor(octave_value dim_ov,
                                   octave_value split_ov,
                                   octave_value node_page_ov)
{
  std::size_t dim = dim_ov.int_value();
  std::string split = split_ov.string_value();
  std::uint32_t node_page = node_page_ov.int_value();

  return new RTreeOct(dim, split, node_page);
}

octave_value RTreeOct::bsrt_read(octave_value fd_ov)
{
  int fd = fd_ov.int_value();

  return new RTreeOct(RTreeC::bsrt_read(fd));
}

octave_value RTreeOct::from_bsrt(octave_value bsrt_ov)
{
  std::string bsrt = bsrt_ov.string_value();

  return new RTreeOct(RTreeC::from_bsrt(bsrt));
}


octave_value RTreeOct::csv_read(octave_value fd_ov,
                                octave_value dim_ov,
                                octave_value split_ov,
                                octave_value node_page_ov)
{
  int fd = fd_ov.int_value();
  std::size_t dim = dim_ov.int_value();
  std::string split = split_ov.string_value();
  std::uint32_t node_page = node_page_ov.int_value();

  return new RTreeOct(RTreeC::csv_read(fd, dim, split, node_page));
}

octave_value RTreeOct::json_read(octave_value fd_ov)
{
  int fd = fd_ov.int_value();

  return new RTreeOct(RTreeC::json_read(fd));
}

octave_value RTreeOct::from_json(octave_value json_ov)
{
  std::string json = json_ov.string_value();

  return new RTreeOct(RTreeC::from_json(json));
}

DEFINE_OV_TYPEID_FUNCTIONS_AND_DATA(RTreeOct, "RTree wrapper", "RTreeOct");
