#include <octave/oct.h>

#include "RTreeStyleOct.h"
#include "keywords.h"

DEFUN_DLD(RTreeStyle_dispatch, args, nargout, "RTreeStyle_dispatch")
{
  std::string method_name = args(0).string_value();

  switch (method_key(method_name))
    {
    case key_json_read:
      {
        octave_value
          fd = args(1),
          val = RTreeStyleOct::json_read(fd);
        return octave_value_list(val);
      }

    case key_from_json:
      {
        octave_value
          json = args(1),
          val = RTreeStyleOct::from_json(json);
        return octave_value_list(val);
      }

    default:
      error_with_id("RTree:BUG", "unknown method: %s",
                    method_name.c_str());
      return octave_value_list();
    }
}
